XkbAddGeomOutline(3)

NAME
XkbAddGeomOutline - Add one outline to an existing shape

SYNOPSIS

XkbOutlinePtr XkbAddGeomOutline (XkbShapePtr shape, int sz_points);

ARGUMENTS

- shape
    shape to be updated

- sz_points
    number of points to be reserved

DESCRIPTION

Xkb provides functions to add a single new element to the top-level keyboard geometry. In each case the num_ * fields of the corresponding structure is incremented by 1. These functions do not change sz_* unless there is no more room in the array. Some of these functions fill in the values of the element's structure from the arguments. For other functions, you must explicitly write code to fill the structure's elements.

The top-level geometry description includes a list of geometry properties. A geometry property associates an arbitrary string with an equally arbitrary name. Programs that display images of keyboards can use geometry properties as hints, but they are not interpreted by Xkb. No other geometry structures refer to geometry properties.

An outline consists of an arbitrary number of points. XkbAddGeomOutline adds an outline to the specified shape by reserving sz_points points for it. The new outline is allocated and zeroed. XkbAddGeomOutline returns NULL if any of the parameters is empty or if it was not able to allocate space. To allocate space for an arbitrary number of outlines to a shape, use XkbAllocGeomOutlines.

STRUCTURES

    typedef struct _XkbOutline {
        unsigned short    num_points;      /* number of points in the outline */
        unsigned short    sz_points;       /* size of the points array */
        unsigned short    corner_radius;   /* draw corners as circles with this radius */
        XkbPointPtr       points;          /* array of points defining the outline */
    } XkbOutlineRec, *XkbOutlinePtr;

SEE ALSO
XkbAllocGeomOutlines(3)